// SetArpStatic.cpp : ܼ  α׷   մϴ.
//

#include "stdafx.h"
#include "ARP.h"
#include <atlstr.h>
void SetArpStatic(unsigned char *pIp);																						// Static ȯ Լ
void GetAdapterIndexList(int* AdapterCount, int* AdapterIndexList);														    // 밡 Adapter  Index List 
bool GetMacID(unsigned char* pIp, int AdapterCount, int* AdapterIndexList, unsigned char* mac, int* AdapterIndex);			// IP  ִ Adapter MAC ID 
void ResetStatic(unsigned char* pIp, unsigned char* mac, int AdapterIndex);
void ResetStaticOtehrVersion(unsigned char* pIp, unsigned char* mac);

int _tmain(int argc, _TCHAR* argv[])
{
	unsigned char	ip[4] = {192,168,0,130};
	//
	// ش IP  Static ȯ
	//
	SetArpStatic(&ip[0]);
	return 0;
}


void SetArpStatic(unsigned char *pIp)
{
	OSVERSIONINFOEX OSvER = {sizeof(OSVERSIONINFOEX),};
	GetVersionEx((OSVERSIONINFO*)&OSvER);

	int AdapterCount = 0;
	int AdapterIndex = 0;
	int AdapterIndexList[256] = {0,};
	unsigned char mac[6] = {0,};

	if(OSvER.dwMajorVersion >=6)   // Windows 7  
	{
		//
		// 밡 Adapter  Adapter index Ʈ  
		GetAdapterIndexList(&AdapterCount, AdapterIndexList);

		//
		// IP  ִ Adapter MAC ID 
		GetMacID(pIp, AdapterCount, AdapterIndexList, (unsigned char*)&mac, &AdapterIndex);

		//
		// Dynamic  Static  
		ResetStatic(pIp, mac, AdapterIndex);
	}
	else						   //    
	{
		GetAdapterIndexList(&AdapterCount, AdapterIndexList);

		GetMacID(pIp, AdapterCount, AdapterIndexList, (unsigned char*)&mac, &AdapterIndex);

		//
		// ٸ  , ش IP MAC ּҸ 
		ResetStaticOtehrVersion(pIp, mac);
	}
}
void GetAdapterIndexList(int* AdapterCount, int* AdapterIndexList)
{
	ULONG				ulBufferSize	= 0;
	PIP_ADAPTER_INFO	pAdapter, pAdapterInfo	= NULL;

	if (GetAdaptersInfo(NULL, &ulBufferSize) == ERROR_BUFFER_OVERFLOW)
	{
		pAdapterInfo	= (PIP_ADAPTER_INFO)new BYTE[ulBufferSize];
		if (pAdapterInfo)
		{
			if (GetAdaptersInfo(pAdapterInfo, &ulBufferSize) == ERROR_SUCCESS)
			{
				pAdapter	= pAdapterInfo;
				(*AdapterCount) = 0;
				while(pAdapter)
				{
					AdapterIndexList[*AdapterCount] = pAdapter->Index;
					pAdapter = pAdapter->Next;
					(*AdapterCount)++;
				}
			}
			delete pAdapterInfo;
		}
	}
}

bool GetMacID(unsigned char* pIp, int AdapterCount, int* AdapterIndexList, unsigned char* mac, int* AdapterIndex)
{
	int i;
	bool bFind = false;

	for(i = 0; i<AdapterCount; i++)
	{
		CARP		arp;
		arpTable	Table[256];
		int			Counter;
		int			TableLength	= sizeof(Table)/sizeof(arpTable);

		Counter	= arp.GetEntries(Table, TableLength, AdapterIndexList[i]);

		for(int j=0; j<Counter; j++)
		{
			if( (Table[j].IPAddress[0] == pIp[0]) && (Table[j].IPAddress[1] == pIp[1]) &&
				(Table[j].IPAddress[2] == pIp[2]) && (Table[j].IPAddress[3] == pIp[3]) )
			{
				memcpy(mac, Table[j].MACAddress, sizeof(char)*6);
				(*AdapterIndex) = AdapterIndexList[i];
				bFind = true;
				break;
			}
		}
		if(bFind) 
		{
			break;
		}
	}
	return false;
}

void ResetStatic(unsigned char* pIp, unsigned char* mac, int AdapterIndex)
{
	SHELLEXECUTEINFO execinfo;

	char strParam[256] = {0, };

	sprintf_s (strParam, 256, " -c \"interface ipv4\" set neighbors %d \"%u.%u.%u.%u\" %02X-%02X-%02X-%02X-%02X-%02X",
		AdapterIndex,									// AdapterIndex
		pIp[0],pIp[1],pIp[2],pIp[3],					// IP
		mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);		// MAC

	ZeroMemory(&execinfo, sizeof(execinfo));
	execinfo.cbSize = sizeof(execinfo);
	execinfo.lpVerb = _T("open");
	execinfo.lpFile = _T("netsh");
	execinfo.lpParameters = strParam;    
	execinfo.nShow = SW_HIDE;

	ShellExecuteEx(&execinfo);

}

void ResetStaticOtehrVersion(unsigned char* pIp, unsigned char* mac)
{
	SHELLEXECUTEINFO execinfo;

	char strParam[256]= {0,};

	sprintf_s (strParam, 256, " -s \"%u.%u.%u.%u\" %02X-%02X-%02X-%02X-%02X-%02X",
		pIp[0],pIp[1],pIp[2],pIp[3],				 //IP
		mac[0],mac[1],mac[2],mac[3],mac[4],mac[5]);  //MAC	

	ZeroMemory(&execinfo, sizeof(execinfo));
	execinfo.cbSize = sizeof(execinfo);
	execinfo.lpVerb = _T("open");
	execinfo.lpFile = _T("arp");
	execinfo.lpParameters = strParam;    
	execinfo.nShow = SW_HIDE;

	ShellExecuteEx(&execinfo);
}